﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Data.OleDb;
using System.Web;
using System.Data;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;

namespace WCFImages.Web
{
    [ServiceContract(Namespace = "")]
    [SilverlightFaultBehavior]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class WCFService
    {
        [OperationContract]
        public ImageEmployee[] GetAllEmp()
        {
            string _path = HttpContext.Current.Server.MapPath(@"~\App_Data\NWind.mdb");
            OleDbConnection Conn = new OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + _path + ";Persist Security Info=False;");
            Conn.Open();
            OleDbCommand Cmd = new OleDbCommand("Select EmployeeID, LastName, FirstName, Title, City, Country, Photo  from Employees", Conn);
            OleDbDataReader Reader = Cmd.ExecuteReader();            

            ImageEmployee[] arrEmp = new ImageEmployee[9];
            int count = 0;
            while (Reader.Read())
            {
                var employee = new ImageEmployee();
                employee.EmployeeID = Reader.GetInt32(0);
                employee.LastName = Reader.GetString(1);
                employee.FirstName = Reader.GetString(2);
                employee.Title = Reader.GetString(3);
                employee.City = Reader.GetString(4);
                employee.Country = Reader.GetString(5);

                byte[] blob = new byte[(Reader.GetBytes(6, 0, null, 0, int.MaxValue))];
                Reader.GetBytes(6, 0, blob, 0, blob.Length);

                using (var ms = new MemoryStream())
                {
                    ms.Write(blob, 78, blob.Length - 78);
                    Bitmap bmp = (Bitmap)Image.FromStream(ms);
                    using (var msJpg = new MemoryStream())
                    {
                        bmp.Save(msJpg, ImageFormat.Jpeg);
                        employee.Photo = msJpg.GetBuffer();
                    }
                }

                arrEmp[count] = employee;
                count++;
            };
            Conn.Close();
            return arrEmp;
        }
    }


    [DataContract]
    public class ImageEmployee
    {
        [DataMember]
        public int EmployeeID { get; set; }
        [DataMember]
        public string LastName { get; set; }
        [DataMember]
        public string FirstName { get; set; }
        [DataMember]
        public string Title { get; set; }
        [DataMember]
        public string City { get; set; }
        [DataMember]
        public string Country { get; set; }
        [DataMember]
        public byte[] Photo { get; set; }
    }
}
