﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.IO;
using System.Windows.Media.Imaging;
using C1.Silverlight;
using WCFImages.ImageService;

namespace WCFImages
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var client = new WCFServiceClient();

            client.GetAllEmpCompleted += (s, e) =>
                {
                    c1DataGrid1.ItemsSource = e.Result;
                };

            client.GetAllEmpAsync();
        }
    }

    # region "IValueConverter"

    /* Implements ‘IValueConverter’ interface and its methods. 
     * The ‘Convert’ method reads byte array and converts it into a memory stream. 
     * This memory stream is then bound with the ‘BitMapImage’ so that it can be 
     * further bound with the Image UI element.*/

    public class ImageConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var imageBytes = (byte[])value;
            MemoryStream memStream = new MemoryStream(imageBytes, false);
            BitmapImage _image = new BitmapImage();
            _image.SetSource(memStream);
            return _image;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
    # endregion
}
